﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinEditors;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win.UltraWinMaskedEdit;

namespace WinGridFormattColumn
{
    public partial class Form1 : Form
    {
        DropDownEditorButton dropDownBtn = new DropDownEditorButton();
        EditorWithMask mask = new EditorWithMask();

        public DataSet GenerateDataSet()
        {
            DataTable table0 = new DataTable("Treatment Fluu");
            table0.Columns.Add("Drug", typeof(string));
            table0.Columns.Add("Dosage", typeof(long));

            table0.Rows.Add("BLq");
            table0.Rows.Add("BLq"); 

            DataSet RetDataSet = new DataSet();
            RetDataSet.Tables.Add(table0);

            return RetDataSet;

        }

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            UltraGrid grid = new UltraGrid();
            dropDownBtn.Control = grid;
            dropDownBtn.AutoFocus = false;
            dropDownBtn.DropDownResizeHandleStyle = DropDownResizeHandleStyle.VerticalResize;
            dropDownBtn.RightAlignDropDown = DefaultableBoolean.False;

            //binding source for the DropDownWithMaskInput
            List<object> vl = new List<object>();
            vl.Add(1234567890);
            vl.Add(2123456789);
            vl.Add(2123456789);

            grid.DisplayLayout.AutoFitStyle = AutoFitStyle.ResizeAllColumns;
            grid.DisplayLayout.Override.CellClickAction = CellClickAction.RowSelect;
            grid.DisplayLayout.Override.SelectTypeRow = SelectType.Single;
            grid.DisplayLayout.Override.SelectTypeCol = SelectType.None;
            grid.DataSource = vl;
            grid.Size = new Size(200, 150);

            mask.ValueChanged += new EventHandler(mask_ValueChanged);
            mask.ButtonsRight.Add(dropDownBtn);
            mask.DisplayFormattedTextWhenNotFocused = false;            

            grid.InitializeLayout += new InitializeLayoutEventHandler(grid_InitializeLayout);
            grid.DoubleClick += new EventHandler(grid_DoubleClick);
            grid.KeyDown += new KeyEventHandler(grid_KeyDown);


            ultraGrid1.DataSource = GenerateDataSet();              
        }

        void grid_KeyDown(object sender, KeyEventArgs e)
        {
            UltraGrid ug = (UltraGrid)sender;
            UltraGridCell cell = (UltraGridCell)ug.Tag;
            if (e.KeyCode == Keys.Escape)
            {
                if (ug.Selected.Rows.Count > 0)
                    ug.Selected.Rows.Clear();
                else
                {
                    Form f = ug.FindForm();
                    cell.Value = null;
                    f.Hide();
                }
                return;
            }
            if (e.KeyCode == Keys.Enter)
            {
                Form f = ug.FindForm();
                switch (ug.Selected.Rows.Count)
                {
                    case 0:
                        cell.Value = null;
                        break;
                    case 1:
                        cell.Value = ug.Selected.Rows[0].Cells[0].Value;
                        break;
                }
                f.Hide();

            }
        }

        void grid_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns[0].Format = "###-####-###";
        }

        void grid_DoubleClick(object sender, EventArgs e)
        {
            UltraGrid ug = (UltraGrid)sender;
            Infragistics.Win.DropDownManager.DropDownForm f = (Infragistics.Win.DropDownManager.DropDownForm)ug.FindForm();
            UltraGridCell cell = (UltraGridCell)ug.Tag;
            switch (ug.Selected.Rows.Count)
            {
                case 0:
                    cell.Value = null;
                    break;
                case 1:
                    cell.Value = ug.Selected.Rows[0].Cells[0].Value;
                    break;
            }

            f.Hide();
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns["Dosage"].Editor = mask;
            e.Layout.Bands[0].Columns["Dosage"].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDown;
            e.Layout.Bands[0].Columns["Dosage"].MaskInput = "###-####-###";
            e.Layout.Bands[0].Columns["Dosage"].Format = "###-####-###";
            e.Layout.Bands[0].Columns["Dosage"].MaskDataMode = MaskMode.IncludeBoth;
            e.Layout.Bands[0].Columns["Dosage"].MaskDisplayMode = MaskMode.IncludeBoth;
        }

        void mask_ValueChanged(object sender, EventArgs e)
        {            
            if (dropDownBtn.IsDroppedDown == false)
            {
                dropDownBtn.DropDown();
            }
        }

        private void ultraGrid1_CellChange(object sender, CellEventArgs e)
        {
           
        }
    }
}
